GameStates.Glitterizer = function (game) {
    this.emitter;
    this.group;
};

GameStates.Glitterizer.prototype = {
    create: function () {
        var stage = game.add.sprite(0, 0, 'stage');
		glitterizedCharacter = null;
		this.group = game.add.group();
		var tex = game.add.renderTexture(game.width, game.height, 'render', true);

        // add shadow
		var shadow = game.add.sprite(game.width / 2, game.height / 2, data.characters[selectedCharacter].name + '-' + selectedPose + '-shadow');
		shadow.anchor.set(0.5);

		this.group.add(shadow);

		// draw character and glitterize the selected parts
		for(var i = 0, ilen = data.characters[selectedCharacter].poses[selectedPose].parts.length; i < ilen; i++) {
			var tempPart = game.add.sprite(game.width / 2, game.height / 2, data.characters[selectedCharacter].poses[selectedPose].parts[i].key);
			tempPart.anchor.set(0.5);
			
			this.group.add(tempPart);
			
			// glitterize the selected parts are overlayed on the character below
			for(var j = 0, jlen = selectedParts.length; j < jlen; j++) {
				if(selectedParts[j] == i) {
					// add respective glitter with mask
				    var bmd = game.make.bitmapData(350, 500);

					//	And create an alpha mask image by combining pic and mask from the cache
					bmd.alphaMask(data.glitters[selectedCanister].key, data.characters[selectedCharacter].poses[selectedPose].parts[i].key);

					var mask = game.add.sprite(game.width / 2, game.height / 2, bmd);
					mask.anchor.set(0.5);
					mask.alpha = 0.7;
					
					this.group.add(mask);
				}
			}
		}
		
		tex.renderXY(this.group, 0, 0);
		glitterizedCharacter = tex;
		this.group.alpha = 0;
		Utils.Tween.In(game, this.group, { alpha: 1 }, { alpha: 1 });
		
        // make emitter
		var particles = [];
		this.emitter = game.add.emitter(game.width / 2, game.height / 2, 50);

        // make an array of all the particles' keys
		data.particles.forEach(function (particle) {
		    particles.push(particle.key);
		});

		this.emitter.makeParticles(particles);

		this.emitter.gravity = -2;
		this.emitter.maxParticleSpeed = new Phaser.Point(20, 20);
		this.emitter.minParticleSpeed = new Phaser.Point(-20, -20);
		this.emitter.width = 250;
		this.emitter.height = 480;
		this.emitter.start(false, 1000, 200);

		game.time.events.add(Phaser.Timer.SECOND * 3, function () {
		        this.showBackground();
		}, this);
    },


    update: function () {
        // fade out the particles
        this.emitter.forEachAlive(function (particle) {
            particle.alpha = game.math.clamp(particle.lifespan / 150, 0, 1);
        }, this);
    },
	
    showBackground: function () {
        Utils.Tween.Out(game, this.group, { alpha: 1 }, { alpha: 0 }, 0, function () {
            this.state.start('SelectBackground');
        }, this);
	}
};