GameStates.Preloader = function() {
	this.loading;
	this.loadingBar;
	this.loadingBarBackground;
};

GameStates.Preloader.prototype = {
	preload: function() {
		game.add.sprite(0, 0, 'stage');
		
		// loading text
		this.loading = this.add.sprite(this.game.width / 2, this.game.height * 0.46, 'loading');
		this.loading.x = this.game.width / 2;
		this.loading.anchor.set(0.5, 1);
		
		// loading bar
		this.loadingBarBackground = this.add.sprite(this.game.width / 2, this.game.height / 2, 'bar-background');
		this.loadingBarBackground.x = this.game.width / 2 - this.loadingBarBackground.width / 2;
		this.loadingBarBackground.anchor.set(0, 0.5);
		
		this.loadingBar = this.add.sprite(this.loadingBarBackground.x, this.loadingBarBackground.y, 'bar');
		this.loadingBar.x = this.game.width / 2 - this.loadingBar.width / 2;
		this.loadingBar.anchor.set(0, 0.5);
		this.load.setPreloadSprite(this.loadingBar, 0);

	    // load images
        // some images are loaded in boot so that they can be used in the loading state
		this.load.image('button-blue', urlAbsoluteAssetPath + 'include/images/buttons/blue.png');
		this.load.image('pointer', urlAbsoluteAssetPath + 'include/images/pointer.png');
		this.load.image('spark', urlAbsoluteAssetPath + 'include/images/spark-white.png');
		this.load.image('spark-pink', urlAbsoluteAssetPath + 'include/images/spark-pink.png');
		this.load.image('canister', urlAbsoluteAssetPath + 'include/images/canister.png');
		this.load.image('canister-mask', urlAbsoluteAssetPath + 'include/images/canister-mask.png');
		this.load.image('backstage', urlAbsoluteAssetPath + 'include/images/backstage.png');
		this.load.image('canister-stroke', urlAbsoluteAssetPath + 'include/images/canister-stroke.png');
		this.load.image('main-menu', urlAbsoluteAssetPath + copy.images.mainTitle);
		
		// loop through and load characters
		for(var i = 0, ilen = data.characters.length; i < ilen; i++) {
		    for (var j = 0, jlen = data.characters[i].poses.length; j < jlen; j++) {
		        // load in shadows
		        this.load.image(data.characters[i].name + '-' + j + '-shadow',
                                urlAbsoluteAssetPath + 'include/images/characters-shadow/' + data.characters[i].name + '/' + j + '/shadow.png');

				for(var k = 0, klen = data.characters[i].poses[j].parts.length; k < klen; k++) {
					var path = data.characters[i].poses[j].parts[k].path;
					data.characters[i].poses[j].parts[k].key = data.characters[i].name + '-' + j + '-' + path.substring(0, path.indexOf('.'));
					
					// remove the '.png' extension for the key
					this.load.image(data.characters[i].poses[j].parts[k].key,
									urlAbsoluteAssetPath + 'include/images/characters/' + data.characters[i].name + '/' + j + '/' + data.characters[i].poses[j].parts[k].path);

                    // add glowing versions of part assets
					this.load.image(data.characters[i].poses[j].parts[k].key + '-glow',
									urlAbsoluteAssetPath + 'include/images/characters-glow/' + data.characters[i].name + '/' + j + '/' + data.characters[i].poses[j].parts[k].path);
				}
			}
		}
		
		// load glitter
		for(var i = 0, len = data.glitters.length; i < len; i++) {
			this.load.image(data.glitters[i].key, urlAbsoluteAssetPath + 'include/images/glitter/' + data.glitters[i].path);
		}
		
		// load backgrounds
		for(var i = 0, len = data.backgrounds.length; i < len; i++) {
			this.load.image(data.backgrounds[i].key, urlAbsoluteAssetPath + 'include/images/backgrounds/' + data.backgrounds[i].path);
		}

	    // load background thumbs
		for (var i = 0, len = data.backgroundThumbs.length; i < len; i++) {
		    this.load.image(data.backgroundThumbs[i].key + '-thumb', urlAbsoluteAssetPath + 'include/images/backgrounds/' + data.backgroundThumbs[i].path);
		}

	    // load sparks
		for (var i = 0, len = data.particles.length; i < len; i++) {
		    this.load.image(data.particles[i].key, urlAbsoluteAssetPath + 'include/images/particles/' + data.particles[i].path);
		}

		this.load.image('glitterizer-back', urlAbsoluteAssetPath + 'include/images/glitterizer-back.png');
		this.load.image('glitterizer-door', urlAbsoluteAssetPath + 'include/images/glitterizer-door.png');
		this.load.image('glitterizer-front', urlAbsoluteAssetPath + 'include/images/glitterizer-front.png');
	},
	
	create: function() {
		// Center the loading bar so it shrinks to the center on the x-axis
		// loading assets are already centered on the y-axis
		this.loadingBarBackground.anchor.set(0.5);
		this.loadingBarBackground.x = this.game.width / 2;
		
		this.loadingBar.anchor.set(0.5);
		this.loadingBar.x = this.loadingBarBackground.x;
		
		// Tween out and start Main Menu
		Utils.Tween.Out(this.game, this.loading.scale, {x: 1.05, y: 1.05 }, {x: 0, y: 0 }, 0);
		Utils.Tween.Out(this.game, this.loadingBarBackground.scale, {x: 1.05, y: 1.05 }, {x: 0, y: 0 }, 0);
		Utils.Tween.Out(this.game, this.loadingBar.scale, {x: 1.05, y: 1.05 }, {x: 0, y: 0 }, 0, (function () {
		    this.state.start('MainMenu');
		}), this);
	}
};