GameStates.SelectCharacter = function () {
	this.title;
	this.titlePosition = new Phaser.Point(40, 50);
	this.titleBottom = this.titlePosition.y + 20;
	
	this.characterY = game.height * 0.55;
	this.characterMarginLeft = 0;
	this.characterPadding = -30;
	this.characters;
	
	this.characterTop = this.characterY - 15;
	this.characterBottom = this.characterY + 50;
	
	this.timeGap = 70;
	this.active;
	
	this.INITIAL_INDEX = 0;
};

GameStates.SelectCharacter.prototype = {
	create: function () {
		// reset variables
		selectedCharacter = 0;
		this.characters = [];
		this.active = true;
		
		// create background
		game.add.sprite(0, 0, 'stage');
		
		// create title for the state
		this.title = new Text(game, this.titlePosition.x, this.titleBottom, copy.characterTitle.toUpperCase(), 'medium', 'center', '#5f259f');
		this.title.alpha = 0;
		
		Utils.Tween.In(game, this.title, { alpha: 1 }, { alpha: 1 });
		Utils.Tween.In(game, this.title, { y: this.titlePosition.y }, { y: this.titlePosition.y });
		
		// create initial poses for the characters
		// show pose index relative to position
		for(var i = 0, ilen = data.characters.length; i < ilen; i++) {
			this.characters.push(game.add.group());
			for(var j = 0, jlen = data.characters[i].poses[this.INITIAL_INDEX].parts.length; j < jlen; j++) {
				var part = new Part(0, 0, data.characters[i].poses[this.INITIAL_INDEX].parts[j].key);
				this.characters[i].add(part);
				this.characters[i].x = (part.width + this.characterPadding) * i + this.characterMarginLeft + (part.width / 2);
				this.characters[i].y = this.characterY;
				this.select(part, i);
			}
			
			// tween in character from right to left
			this.characters[i].y = this.characterBottom;
			this.characters[i].alpha = 0;
			Utils.Tween.In(game, this.characters[i], { alpha: 1 }, { alpha: 1 }, ilen * this.timeGap - i * this.timeGap);
			Utils.Tween.In(game, this.characters[i], { y: this.characterTop }, { y: this.characterY }, ilen * this.timeGap - i * this.timeGap);
		}
	},
	
	select: function (part, index) {
	    part.events.onInputDown.add((function () {
	        if (this.active) {
	            var finalPick = this.characters[index];
	            this.characters.splice(index, 1);

	            for (var i = 0, len = this.characters.length; i < len; i++) {
	                Utils.Tween.Out(game, this.characters[i], { alpha: 1 }, { alpha: 0 }, i * this.timeGap);

	                // on the last element animation call next state
	                if (i < len - 1) {
	                    Utils.Tween.Out(game, this.characters[i], { y: this.characterTop }, { y: this.characterBottom }, i * this.timeGap);
	                }
	                else {
	                    Utils.Tween.In(game, this.title, { alpha: 1 }, { alpha: 0 }, i * this.timeGap);
	                    Utils.Tween.In(game, this.title, { y: this.titlePosition.y }, { y: this.titleBottom }, i * this.timeGap);
	                    Utils.Tween.Out(game, this.characters[i], { y: this.characterTop }, { y: this.characterBottom }, i * this.timeGap, function () {
	                        var bounce = 15;

	                        if (index == 0) {
	                            bounce = 0;
	                        }

	                        Utils.Tween.In(game, finalPick, { x: this.characterMarginLeft + (finalPick.width / 2) - bounce }, { x: this.characterMarginLeft + (finalPick.width / 2) }, 0, function () {
	                            selectedCharacter = index;
	                            this.state.start('SelectPose');
	                        }, this);
	                    }, this);
	                }
	            }
	        }

	        this.active = false;
	    }), this);
	}
};
