GameStates.SelectPose = function () {
	this.title;
	this.titlePosition = new Phaser.Point(40, 50);
	this.titleBottom = this.titlePosition.y + 20;
	
	this.characterY = game.height * 0.55;
	this.characterMarginLeft = 0;
	this.characterPadding = -30;
	this.characters;
	
	this.title;
	this.active;
};

GameStates.SelectPose.prototype = {
	create: function () {
		// reset variables
		selectedPose = 0;
		this.characters = [];
		this.active = true;
		
		// create background
		game.add.sprite(0, 0, 'stage');
		
		// create title for the state
		this.title = new Text(game, this.titlePosition.x, this.titleBottom, copy.poseTitle.toUpperCase(), 'medium', 'center', '#5f259f');
		
		Utils.Tween.In(game, this.title, { alpha: 1 }, { alpha: 1 });
		Utils.Tween.In(game, this.title, { y: this.titlePosition.y }, { y: this.titlePosition.y });
		
		// create poses of selected character
		for(var i = 0, ilen = data.characters[selectedCharacter].poses.length; i < ilen; i++) {
			this.characters.push(game.add.group());
			for(var j = 0, jlen = data.characters[selectedCharacter].poses[i].parts.length; j < jlen; j++) {
				var part = new Part(0, this.characterY, data.characters[selectedCharacter].poses[i].parts[j].key);
				part.x = (part.width + this.characterPadding) * i + this.characterMarginLeft + (part.width / 2);
				this.characters[i].add(part);
				this.select(part, i);
			}
			
			// tween in character from right to left
			if(i != selectedPose) {
				this.characters[i].y = 50;
				this.characters[i].alpha = 0;
				Utils.Tween.In(game, this.characters[i], { alpha: 1 }, { alpha: 1 }, ilen * 70 - i * 70);
				Utils.Tween.In(game, this.characters[i], { y: -15 }, { y: 0 }, ilen * 70 - i * 70);
			}
		}
	},
	
	select: function (part, index) {
	    part.events.onInputDown.add((function () {
	        if (this.active) {
	            var finalPick = this.characters[index];
	            this.characters.splice(index, 1);

	            for (var i = 0, len = this.characters.length; i < len; i++) {
	                Utils.Tween.Out(game, this.characters[i], { alpha: 1 }, { alpha: 0 }, i * 70);

	                // on the last element animation call next state
	                if (i < len - 1) {
	                    Utils.Tween.Out(game, this.characters[i], { y: -15 }, { y: 50 }, i * 70);
	                }
	                else {
	                    Utils.Tween.In(game, this.title, { alpha: 1 }, { alpha: 0 }, i * this.timeGap);
	                    Utils.Tween.In(game, this.title, { y: this.titlePosition.y }, { y: this.titleBottom }, i * this.timeGap);
	                    Utils.Tween.Out(game, this.characters[i], { y: -15 }, { y: 50 }, i * 70,
                            (function () {
                                Utils.Tween.Out(game, finalPick, { alpha: 1 }, { alpha: 0 });
                                Utils.Tween.Out(game, finalPick, { y: -15 }, { y: 50 }, 0, (function () {
                                    selectedPose = index;
                                    this.state.start('SelectGlitter');
                                }), this);
                            }), this);
	                }
	            }
	        }

	        this.active = false;
		}), this);
	}
};