var imageSource;

GameStates.ShowImage = function (game) {
    this.emitter;
    this.picture;
};

GameStates.ShowImage.prototype = {
	create: function () {
		// create background
	    game.add.sprite(0, 0, 'stage');
	    this.picture = game.add.group();
		
		// create character and background
		// make the background a mask
		var background = game.add.sprite(game.width / 2, game.height / 2, data.backgrounds[selectedBackground].key);
		background.anchor.set(0.5);

		this.picture.add(background);

		var sprite = new Phaser.Sprite(game, game.width / 2 + data.positions[selectedBackground].x,
									 game.height / 2 + data.positions[selectedBackground].y,
									 glitterizedCharacter);
		sprite.scale.set(data.positions[selectedBackground].scale);
		sprite.anchor.set(0.5);

		
		//	A mask is a Graphics object
		var mask = game.add.graphics(0, 0);
		mask.beginFill(0xffffff);
		mask.drawRect(background.x - background.width / 2, background.y - background.height / 2, background.width, background.height);
		
		//	And apply it to the Sprite
		sprite.mask = mask;

		var tex = game.add.renderTexture(game.width, game.height, 'render', true);
		tex.renderXY(sprite, game.width / 2 + data.positions[selectedBackground].x, game.height / 2 + data.positions[selectedBackground].y);
		var temp = game.add.sprite(0, 0, tex);

		this.picture.add(temp);
		
		// show save button
		saveButton.className = "active";
		replayButton.className = "active";

	    // make emitter
		var particles = [];
		this.emitter = game.add.emitter(game.width / 2 + data.positions[selectedBackground].x,
                                        game.height / 2 + data.positions[selectedBackground].y, 50);

        // make an array of all the particles' keys
		data.particles.forEach(function (particle) {
		    particles.push(particle.key);
		});

		this.emitter.makeParticles(particles);

		this.emitter.gravity = -2;
		this.emitter.maxParticleSpeed = new Phaser.Point(20, 20);
		this.emitter.minParticleSpeed = new Phaser.Point(-20, -20);
		this.emitter.width = 250 * data.positions[selectedBackground].scale;
		this.emitter.height = 500 * data.positions[selectedBackground].scale;
		this.emitter.start(false, 1000, 200);

		this.picture.add(this.emitter);

	    // create text
		var imageText = new Text(game, game.width / 2, 20, copy.saveText.toUpperCase(), 'small', 'center', '#5f259f');
		imageText.anchor.set(0.5, 0);
		imageText.wordWrapWidth = 450;

        // save source of generated group, so that the image saved doesn't have text on it
		var sourceTexture = this.picture.generateTexture();
		imageSource = sourceTexture.baseTexture.source;
	},

	update: function () {
        // fade out the particles
	    this.emitter.forEachAlive(function (particle) {
	        particle.alpha = game.math.clamp(particle.lifespan / 150, 0, 1);
	    }, this);
	},
	
	reset: function () {
		// hide save button
		saveButton.className = "";
		replayButton.className = "";
		
		// restart
		this.state.start('CharacterSelect');
	}
};